/* A Bison parser, made by GNU Bison 2.7.12-4996.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.12-4996"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "grammar.y"

#include "config.h"

#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pwd.h>

#ifdef HAVE_RPC_RPC_H
# include <rpc/rpc.h>
#endif
#ifdef HAVE_RPC_PMAP_CLNT_H
# include <rpc/pmap_clnt.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sysexits.h>
#include <syslog.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <regex.h>

#include "installpaths.h"
#include "port/port.h"

#if HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# if HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif
# if HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif
# if HAVE_NDIR_H
#  include <ndir.h>
# endif
#endif

#ifdef HAVE_NET_BPF_H
# include <net/bpf.h>
#endif

#include "assemble.h"
#include "bytecode.h"
#include "data.h"
#include "db.h"
#include "error.h"
#include "grammar.h"
#include "lex.h"
#include "libdb.h"
#include "parse.h"
#include "rlinetd.h"
#include "signals.h"
#include "util.h"

#define RL_PWARN(x...)			rl_pwarn(curfile_name, curfile_line, x)
#define RL_PFATAL(x,y...)		rl_pfatal(x, curfile_name, curfile_line, y)

struct userdata *userdata;

static struct service *current_service;
extern FILE *yyin;
extern char *rl_config;
char **files = NULL;
static int curfile = -1, numfiles = 0;
char *curfile_name = NULL;  /* name of the current file */
int curfile_line = 1;					 /* line */

static struct service *defaults;
static struct opmetalist *opml_defaults;

static struct logdata *logcur, *logdatas;

static struct numlist *numlist = NULL;
static struct stringlist *stringlist = NULL;

extern void yyerror(const char *c);
extern int yywrap(void);
extern int yylex(void);
static int bind_ports(void);
static int add_user_group(const struct service* current_service, struct opmetalist * l);
static void service_copy(struct service *to, struct service *from);
static void service_free(struct service *s);
static struct service *service_new(void);
#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto);
#endif
static struct logdata *logdata_get(char *name);
static struct logdata *logdata_new(void);
static void pidtab_fixup(void);
static void validate_service(struct service *s);
static void add_directory(char *dir, char *match, char *ignore);
static int chargen_buffer(void);

/* Line 371 of yacc.c  */
#line 174 "grammar.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_GRAMMAR_H_INCLUDED
# define YY_YY_GRAMMAR_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_SERVICE = 258,
     T_PORT = 259,
     T_EXEC = 260,
     T_PROTO = 261,
     T_UDP = 262,
     T_TCP = 263,
     T_UID = 264,
     T_GID = 265,
     T_BACKLOG = 266,
     T_INSTANCES = 267,
     T_WAIT = 268,
     T_DEFAULT = 269,
     T_NICE = 270,
     T_INTERFACE = 271,
     T_ANY = 272,
     T_FISH = 273,
     T_CHROOT = 274,
     T_SERVER = 275,
     T_DIR = 276,
     T_RPC = 277,
     T_VERSION = 278,
     T_NAME = 279,
     T_WRAP = 280,
     T_CAPS = 281,
     T_FAMILY = 282,
     T_IPV4 = 283,
     T_IPV6 = 284,
     T_INITGROUPS = 285,
     T_BANNER = 286,
     T_ECHO = 287,
     T_DISCARD = 288,
     T_FILTER = 289,
     T_CHARGEN = 290,
     T_LOOPBACK = 291,
     T_ENABLED = 292,
     T_RLIMIT = 293,
     T_LIM_CPU = 294,
     T_LIM_FSIZE = 295,
     T_LIM_DATA = 296,
     T_LIM_STACK = 297,
     T_LIM_CORE = 298,
     T_LIM_RSS = 299,
     T_LIM_NPROC = 300,
     T_LIM_NOFILE = 301,
     T_LIM_MEMLOCK = 302,
     T_LIM_INFINITY = 303,
     T_SOFT = 304,
     T_HARD = 305,
     T_YES = 306,
     T_NO = 307,
     T_LOG = 308,
     T_PIPE = 309,
     T_SYSLOG = 310,
     T_PATH = 311,
     T_MODE = 312,
     T_ACCEPT = 313,
     T_DENY = 314,
     T_CLOSE = 315,
     T_EXIT = 316,
     T_NUMERIC = 317,
     T_QSTRING = 318,
     T_IPADDR = 319
   };
#endif
/* Tokens.  */
#define T_SERVICE 258
#define T_PORT 259
#define T_EXEC 260
#define T_PROTO 261
#define T_UDP 262
#define T_TCP 263
#define T_UID 264
#define T_GID 265
#define T_BACKLOG 266
#define T_INSTANCES 267
#define T_WAIT 268
#define T_DEFAULT 269
#define T_NICE 270
#define T_INTERFACE 271
#define T_ANY 272
#define T_FISH 273
#define T_CHROOT 274
#define T_SERVER 275
#define T_DIR 276
#define T_RPC 277
#define T_VERSION 278
#define T_NAME 279
#define T_WRAP 280
#define T_CAPS 281
#define T_FAMILY 282
#define T_IPV4 283
#define T_IPV6 284
#define T_INITGROUPS 285
#define T_BANNER 286
#define T_ECHO 287
#define T_DISCARD 288
#define T_FILTER 289
#define T_CHARGEN 290
#define T_LOOPBACK 291
#define T_ENABLED 292
#define T_RLIMIT 293
#define T_LIM_CPU 294
#define T_LIM_FSIZE 295
#define T_LIM_DATA 296
#define T_LIM_STACK 297
#define T_LIM_CORE 298
#define T_LIM_RSS 299
#define T_LIM_NPROC 300
#define T_LIM_NOFILE 301
#define T_LIM_MEMLOCK 302
#define T_LIM_INFINITY 303
#define T_SOFT 304
#define T_HARD 305
#define T_YES 306
#define T_NO 307
#define T_LOG 308
#define T_PIPE 309
#define T_SYSLOG 310
#define T_PATH 311
#define T_MODE 312
#define T_ACCEPT 313
#define T_DENY 314
#define T_CLOSE 315
#define T_EXIT 316
#define T_NUMERIC 317
#define T_QSTRING 318
#define T_IPADDR 319



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 107 "grammar.y"

	long num;
	char *cp;
	struct passwd *uid;
	struct group *gid;
	struct opmetalist *opml;
	struct opmeta *opm;
	rlim_t rl;


/* Line 387 of yacc.c  */
#line 356 "grammar.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_GRAMMAR_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 384 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   361

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  70
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  113
/* YYNRULES -- Number of states.  */
#define YYNSTATES  215

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   319

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    68,    69,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    65,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    66,     2,    67,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    20,
      25,    31,    37,    39,    41,    44,    46,    50,    54,    58,
      62,    67,    73,    75,    78,    80,    83,    86,    88,    90,
      92,    95,    98,   102,   106,   109,   113,   117,   120,   124,
     129,   133,   137,   142,   146,   150,   154,   160,   165,   169,
     172,   175,   178,   182,   185,   188,   189,   191,   193,   197,
     201,   205,   209,   213,   217,   221,   225,   229,   234,   238,
     242,   244,   247,   251,   255,   257,   261,   263,   267,   269,
     272,   276,   280,   282,   286,   288,   290,   294,   296,   298,
     301,   305,   307,   309,   311,   313,   315,   317,   319,   321,
     323,   325,   327,   329,   331,   333,   335,   337,   339,   341,
     343,   345,   348,   350
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      71,     0,    -1,    72,    -1,    71,    72,    -1,    79,    -1,
      78,    -1,    74,    -1,    73,    -1,    21,    63,    65,    -1,
      21,    63,    63,    65,    -1,    21,    63,    63,    63,    65,
      -1,    53,    63,    66,    75,    67,    -1,    76,    -1,    77,
      -1,    76,    77,    -1,    65,    -1,    56,    63,    65,    -1,
       9,    99,    65,    -1,    10,   100,    65,    -1,    57,    62,
      65,    -1,    14,    66,    80,    67,    -1,     3,    63,    66,
      80,    67,    -1,    85,    -1,    80,    85,    -1,    83,    -1,
      80,    83,    -1,    80,    82,    -1,    82,    -1,    82,    -1,
      83,    -1,    81,    83,    -1,    81,    82,    -1,     5,    63,
      65,    -1,     9,    99,    65,    -1,    30,    65,    -1,    30,
     104,    65,    -1,    15,   103,    65,    -1,    18,    65,    -1,
      38,    98,    96,    -1,    53,    55,    63,    65,    -1,    31,
      63,    65,    -1,    35,    84,    65,    -1,    53,    63,    63,
      65,    -1,    10,   100,    65,    -1,    19,    63,    65,    -1,
      26,    63,    65,    -1,    25,    63,    66,    81,    67,    -1,
      25,    66,    81,    67,    -1,    25,    63,    65,    -1,    25,
      65,    -1,    60,    65,    -1,    61,    65,    -1,    32,    63,
      65,    -1,    36,    65,    -1,    33,    65,    -1,    -1,    63,
      -1,    65,    -1,     4,    94,    65,    -1,     6,   101,    65,
      -1,    11,    62,    65,    -1,    12,    62,    65,    -1,    13,
     104,    65,    -1,    37,   104,    65,    -1,    16,    92,    65,
      -1,    16,    17,    65,    -1,    20,    63,    65,    -1,    22,
      66,    86,    67,    -1,    27,   102,    65,    -1,    34,    63,
      65,    -1,    87,    -1,    86,    87,    -1,    24,    63,    65,
      -1,    23,    88,    65,    -1,    89,    -1,    88,    68,    89,
      -1,    62,    -1,    62,    69,    62,    -1,    91,    -1,    90,
      91,    -1,    49,    97,    65,    -1,    50,    97,    65,    -1,
      93,    -1,    92,    68,    93,    -1,    64,    -1,    95,    -1,
      94,    68,    95,    -1,    63,    -1,    62,    -1,    97,    65,
      -1,    66,    90,    67,    -1,    62,    -1,    48,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    62,    -1,    63,
      -1,    62,    -1,    63,    -1,     8,    -1,     7,    -1,    28,
      -1,    29,    -1,    62,    -1,    69,    62,    -1,    51,    -1,
      52,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   147,   147,   148,   151,   152,   153,   154,   157,   159,
     161,   165,   180,   206,   207,   210,   211,   222,   230,   238,
     249,   267,   396,   400,   404,   415,   423,   431,   437,   441,
     452,   460,   470,   491,   512,   519,   529,   533,   537,   541,
     549,   561,   581,   595,   609,   613,   628,   643,   660,   677,
     696,   700,   704,   708,   718,   728,   729,   732,   733,   740,
     744,   748,   752,   756,   760,   767,   773,   778,   779,   780,
     795,   796,   799,   803,   810,   811,   814,   818,   828,   829,
     832,   836,   842,   843,   846,   852,   853,   856,   860,   870,
     874,   885,   887,   891,   900,   909,   918,   927,   936,   945,
     954,   963,   973,   978,   986,   991,   999,  1005,  1013,  1017,
    1028,  1032,  1038,  1042
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_SERVICE", "T_PORT", "T_EXEC",
  "T_PROTO", "T_UDP", "T_TCP", "T_UID", "T_GID", "T_BACKLOG",
  "T_INSTANCES", "T_WAIT", "T_DEFAULT", "T_NICE", "T_INTERFACE", "T_ANY",
  "T_FISH", "T_CHROOT", "T_SERVER", "T_DIR", "T_RPC", "T_VERSION",
  "T_NAME", "T_WRAP", "T_CAPS", "T_FAMILY", "T_IPV4", "T_IPV6",
  "T_INITGROUPS", "T_BANNER", "T_ECHO", "T_DISCARD", "T_FILTER",
  "T_CHARGEN", "T_LOOPBACK", "T_ENABLED", "T_RLIMIT", "T_LIM_CPU",
  "T_LIM_FSIZE", "T_LIM_DATA", "T_LIM_STACK", "T_LIM_CORE", "T_LIM_RSS",
  "T_LIM_NPROC", "T_LIM_NOFILE", "T_LIM_MEMLOCK", "T_LIM_INFINITY",
  "T_SOFT", "T_HARD", "T_YES", "T_NO", "T_LOG", "T_PIPE", "T_SYSLOG",
  "T_PATH", "T_MODE", "T_ACCEPT", "T_DENY", "T_CLOSE", "T_EXIT",
  "T_NUMERIC", "T_QSTRING", "T_IPADDR", "';'", "'{'", "'}'", "','", "'-'",
  "$accept", "tles", "tle", "directory", "log", "log_element",
  "file_elements", "file_element", "default", "service",
  "service_elements", "opcode_block", "complex_opcode_element",
  "opcode_element", "optionalstring", "service_element", "rpcents",
  "rpcent", "numrangelist", "numrange", "limitents", "limitent",
  "ipaddrlists", "ipaddrlist", "portlists", "portlist", "limit",
  "limitvalue", "limittype", "userid", "groupid", "protocol", "family",
  "signed_numeric", "boolean", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    59,   123,   125,    44,    45
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    70,    71,    71,    72,    72,    72,    72,    73,    73,
      73,    74,    75,    76,    76,    77,    77,    77,    77,    77,
      78,    79,    80,    80,    80,    80,    80,    80,    81,    81,
      81,    81,    82,    82,    82,    82,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    84,    84,    85,    85,    85,
      85,    85,    85,    85,    85,    85,    85,    85,    85,    85,
      86,    86,    87,    87,    88,    88,    89,    89,    90,    90,
      91,    91,    92,    92,    93,    94,    94,    95,    95,    96,
      96,    97,    97,    98,    98,    98,    98,    98,    98,    98,
      98,    98,    99,    99,   100,   100,   101,   101,   102,   102,
     103,   103,   104,   104
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     3,     4,
       5,     5,     1,     1,     2,     1,     3,     3,     3,     3,
       4,     5,     1,     2,     1,     2,     2,     1,     1,     1,
       2,     2,     3,     3,     2,     3,     3,     2,     3,     4,
       3,     3,     4,     3,     3,     3,     5,     4,     3,     2,
       2,     2,     3,     2,     2,     0,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     4,     3,     3,
       1,     2,     3,     3,     1,     3,     1,     3,     1,     2,
       3,     3,     1,     3,     1,     1,     3,     1,     1,     2,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     2,     7,     6,     5,
       4,     0,     0,     0,     0,     1,     3,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      55,     0,     0,     0,     0,     0,     0,    57,     0,    27,
      24,    22,     0,     8,     0,     0,    88,    87,     0,    85,
       0,   107,   106,     0,   102,   103,     0,   104,   105,     0,
       0,     0,   112,   113,     0,   110,     0,     0,     0,    84,
       0,    82,    37,     0,     0,     0,     0,    49,     0,     0,
     108,   109,     0,    34,     0,     0,     0,    54,     0,    56,
       0,    53,     0,    93,    94,    95,    96,    97,    98,    99,
     100,   101,     0,     0,     0,    50,    51,    20,    26,    25,
      23,     0,     9,     0,     0,     0,     0,    15,     0,    12,
      13,    21,    58,     0,    32,    59,    33,    43,    60,    61,
      62,   111,    36,    65,    64,     0,    44,    66,     0,     0,
       0,    70,    48,     0,     0,    28,    29,    45,    68,    35,
      40,    52,    69,    41,    63,    92,    91,     0,    38,     0,
       0,     0,    10,     0,     0,     0,     0,    11,    14,    86,
      83,    76,     0,    74,     0,    67,    71,     0,    47,    31,
      30,     0,     0,     0,    78,    89,    39,    42,    17,    18,
      16,    19,     0,    73,     0,    72,    46,     0,     0,    90,
      79,    77,    75,    80,    81
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,     7,     8,   128,   129,   130,     9,    10,
      48,   154,    49,    50,   100,    51,   150,   151,   182,   183,
     193,   194,    80,    81,    58,    59,   168,   169,   112,    66,
      69,    63,    92,    77,    74
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -59
static const yytype_int16 yypact[] =
{
      12,   -58,   -23,     3,    14,    60,   -59,   -59,   -59,   -59,
     -59,    37,   263,    20,    55,   -59,   -59,   263,   -41,    51,
      63,    47,    49,    70,    73,    64,   -52,   -16,    77,    97,
      98,    93,    10,    99,    89,   -38,   100,   101,   102,   103,
     105,   104,    64,    48,   -47,   107,   108,   -59,    19,   -59,
     -59,   -59,    39,   -59,     2,   118,   -59,   -59,    31,   -59,
     109,   -59,   -59,   110,   -59,   -59,   112,   -59,   -59,   117,
     119,   122,   -59,   -59,   123,   -59,   129,   127,   128,   -59,
      32,   -59,   -59,   130,   133,    96,    81,   -59,   300,   134,
     -59,   -59,   135,   -59,   140,   143,   145,   -59,   146,   -59,
     147,   -59,   148,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,    16,   131,   151,   -59,   -59,   -59,   -59,   -59,
     -59,   152,   -59,    47,    49,   153,   156,   -59,   154,     2,
     -59,   -59,   -59,   -41,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,   -59,   106,   -59,   -59,   160,   163,
     -20,   -59,   -59,   300,   171,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,   -59,   -59,   -59,    76,   -59,   158,
     162,   165,   -59,   168,   169,   172,   174,   -59,   -59,   -59,
     -59,   175,    33,   -59,   182,   -59,   -59,   210,   -59,   -59,
     -59,   -42,   -42,   -31,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   187,   -59,   160,   -59,   -59,   185,   186,   -59,
     -59,   -59,   -59,   -59,   -59
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -59,   -59,   247,   -59,   -59,   -59,   -59,    36,   -59,   -59,
     236,   111,   -48,   -46,   -59,    13,   -59,   115,   -59,    50,
     -59,    62,   -59,   113,   -59,   124,   -59,   -34,   -59,   136,
     132,   -59,   -59,   -59,    27
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
     118,    78,   119,   148,   149,    11,   165,   118,   113,   119,
      75,   123,   124,    72,    73,     1,   114,    76,   191,   192,
     166,    56,    57,    18,    19,    20,     2,    93,    21,    22,
      23,    24,    25,     3,    26,    27,   209,    28,    29,    30,
     155,    31,   156,    12,    32,    33,    34,   185,    79,    35,
      36,    37,    38,    39,    40,    41,    42,    43,   125,   126,
      15,   120,    94,     1,   165,     4,    13,   127,   120,   102,
      61,    62,    44,    86,     2,    87,    88,    14,   166,    45,
      46,     3,   167,    52,    47,    53,   117,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   132,   144,   203,   133,
     145,   204,   121,    17,   122,   155,   189,   156,   190,    64,
      65,    67,    68,     4,    60,    72,    73,    90,    91,   148,
     149,    54,    18,    19,    20,   191,   192,    21,    22,    23,
      24,    25,    70,    26,    27,    71,    28,    29,    30,   189,
      31,   190,    82,    32,    33,    34,   152,   153,    35,    36,
      37,    38,    39,    40,    41,    42,    43,   207,   208,    85,
      83,    84,    89,    95,    96,   178,    98,    97,    99,   101,
      79,    44,   115,   116,   134,   135,    19,   136,    45,    46,
      21,    22,   137,    47,   138,   131,    26,   139,   140,    28,
      29,   141,   142,   143,   170,   146,    32,    33,   147,   157,
     158,    35,    36,    37,    38,   159,    40,    41,   160,    43,
     161,   162,   163,   164,   171,    19,   175,   172,   176,    21,
      22,   177,   181,   195,    44,    26,   184,   196,    28,    29,
     197,    45,    46,   198,   199,    32,    33,   200,   188,   201,
      35,    36,    37,    38,   202,    40,    41,   205,    43,   211,
     213,   214,    16,    55,   212,   210,   174,   179,   180,   173,
       0,     0,     0,    44,   187,   186,     0,    18,    19,    20,
      45,    46,    21,    22,    23,    24,    25,   206,    26,    27,
       0,    28,    29,    30,     0,    31,     0,     0,    32,    33,
      34,     0,     0,    35,    36,    37,    38,    39,    40,    41,
      42,    43,     0,     0,     0,    19,     0,     0,     0,    21,
      22,     0,     0,     0,     0,    26,    44,     0,    28,    29,
       0,     0,     0,    45,    46,    32,    33,     0,    47,     0,
      35,    36,    37,    38,     0,    40,    41,     0,    43,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    44,     0,     0,     0,     0,     0,     0,
      45,    46
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-59)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
      48,    17,    48,    23,    24,    63,    48,    55,    55,    55,
      62,     9,    10,    51,    52,     3,    63,    69,    49,    50,
      62,    62,    63,     4,     5,     6,    14,    65,     9,    10,
      11,    12,    13,    21,    15,    16,    67,    18,    19,    20,
      88,    22,    88,    66,    25,    26,    27,    67,    64,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    56,    57,
       0,    48,    35,     3,    48,    53,    63,    65,    55,    42,
       7,     8,    53,    63,    14,    65,    66,    63,    62,    60,
      61,    21,    66,    63,    65,    65,    67,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    65,    65,    65,    68,
      68,    68,    63,    66,    65,   153,   154,   153,   154,    62,
      63,    62,    63,    53,    63,    51,    52,    28,    29,    23,
      24,    66,     4,     5,     6,    49,    50,     9,    10,    11,
      12,    13,    62,    15,    16,    62,    18,    19,    20,   187,
      22,   187,    65,    25,    26,    27,    65,    66,    30,    31,
      32,    33,    34,    35,    36,    37,    38,   191,   192,    66,
      63,    63,    63,    63,    63,   129,    63,    65,    63,    65,
      64,    53,    65,    65,    65,    65,     5,    65,    60,    61,
       9,    10,    65,    65,    65,    67,    15,    65,    65,    18,
      19,    62,    65,    65,    63,    65,    25,    26,    65,    65,
      65,    30,    31,    32,    33,    65,    35,    36,    65,    38,
      65,    65,    65,    65,    63,     5,    63,    65,    62,     9,
      10,    67,    62,    65,    53,    15,    63,    65,    18,    19,
      65,    60,    61,    65,    65,    25,    26,    65,    67,    65,
      30,    31,    32,    33,    69,    35,    36,    65,    38,    62,
      65,    65,     5,    17,   204,   193,   124,   133,   145,   123,
      -1,    -1,    -1,    53,   153,   150,    -1,     4,     5,     6,
      60,    61,     9,    10,    11,    12,    13,    67,    15,    16,
      -1,    18,    19,    20,    -1,    22,    -1,    -1,    25,    26,
      27,    -1,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    -1,    -1,     5,    -1,    -1,    -1,     9,
      10,    -1,    -1,    -1,    -1,    15,    53,    -1,    18,    19,
      -1,    -1,    -1,    60,    61,    25,    26,    -1,    65,    -1,
      30,    31,    32,    33,    -1,    35,    36,    -1,    38,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      60,    61
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    14,    21,    53,    71,    72,    73,    74,    78,
      79,    63,    66,    63,    63,     0,    72,    66,     4,     5,
       6,     9,    10,    11,    12,    13,    15,    16,    18,    19,
      20,    22,    25,    26,    27,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    53,    60,    61,    65,    80,    82,
      83,    85,    63,    65,    66,    80,    62,    63,    94,    95,
      63,     7,     8,   101,    62,    63,    99,    62,    63,   100,
      62,    62,    51,    52,   104,    62,    69,   103,    17,    64,
      92,    93,    65,    63,    63,    66,    63,    65,    66,    63,
      28,    29,   102,    65,   104,    63,    63,    65,    63,    63,
      84,    65,   104,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    98,    55,    63,    65,    65,    67,    82,    83,
      85,    63,    65,     9,    10,    56,    57,    65,    75,    76,
      77,    67,    65,    68,    65,    65,    65,    65,    65,    65,
      65,    62,    65,    65,    65,    68,    65,    65,    23,    24,
      86,    87,    65,    66,    81,    82,    83,    65,    65,    65,
      65,    65,    65,    65,    65,    48,    62,    66,    96,    97,
      63,    63,    65,    99,   100,    63,    62,    67,    77,    95,
      93,    62,    88,    89,    63,    67,    87,    81,    67,    82,
      83,    49,    50,    90,    91,    65,    65,    65,    65,    65,
      65,    65,    69,    65,    68,    65,    67,    97,    97,    67,
      91,    62,    89,    65,    65
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:
/* Line 1787 of yacc.c  */
#line 158 "grammar.y"
    {	add_directory((yyvsp[(2) - (3)].cp), NULL, NULL);	}
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 160 "grammar.y"
    {	add_directory((yyvsp[(2) - (4)].cp), (yyvsp[(3) - (4)].cp), NULL);	}
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 162 "grammar.y"
    {	add_directory((yyvsp[(2) - (5)].cp), (yyvsp[(3) - (5)].cp), (yyvsp[(4) - (5)].cp));	}
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 166 "grammar.y"
    {
		if(logdata_get((yyvsp[(2) - (5)].cp))) {
			RL_PWARN("duplicate declaration of log %s, ignoring", (yyvsp[(2) - (5)].cp));
			free((yyvsp[(2) - (5)].cp));
		} else {
			logcur->name = (yyvsp[(2) - (5)].cp);
			logcur->next = logdatas;
			logdatas = logcur;
			logcur = logdata_new();
		}
		clearuserdata(&userdata);
	}
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 181 "grammar.y"
    {
		if(!logcur->path) {
			RL_PWARN(_("No path defined for log %s"), logcur->name);
		} else {
			if((logcur->index = open(logcur->path, O_CREAT|O_APPEND|O_WRONLY, logcur->mode)) < 0) {
				RL_PWARN(_("open(\"%s\", O_CREAT|O_APPEND|O_WRONLY, 0%o) failed (%s)"),
								logcur->path, logcur->mode, strerror(errno));
			} else {

				if(fchmod(logcur->index, logcur->mode)) {
					RL_PWARN(_("fchmod(\"%s\", 0%o) failed (%s)"),
									logcur->path, logcur->mode,
									strerror(errno));
				}

				if(fchown(logcur->index, logcur->uid, logcur->gid)) {
					RL_PWARN(_("fchown(\"%s\", %d, %d) failed for log %s (%s)"),
									logcur->path, logcur->uid, logcur->gid, logcur->name,
									strerror(errno));
				}
			}
		}
	}
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 212 "grammar.y"
    {
		if(logcur->path) {
			RL_PWARN(_("duplicate path declaration (%s) "
				"in log directive %s, ignoring"), (yyvsp[(2) - (3)].cp),
				logcur->name);
			free((yyvsp[(2) - (3)].cp));
		} else {
			logcur->path = (yyvsp[(2) - (3)].cp);
		}
	}
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 223 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].uid)) {
			logcur->uid = (yyvsp[(2) - (3)].uid)->pw_uid;
		} else {
			RL_PWARN("unknown username");
		}
	}
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 231 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].gid)) {
			logcur->gid = (yyvsp[(2) - (3)].gid)->gr_gid;
		} else {
			RL_PWARN("unknown groupname");
		}
	}
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 239 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].num) > 07777)  {
			RL_PWARN(_("invalid mode declaration "
				"in log directive %s, ignoring"), logcur->name);
		} else {
			logcur->mode = (yyvsp[(2) - (3)].num);
		}
	}
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 250 "grammar.y"
    {
		/* swich pointers to current_service and defaults */
		struct service * saved_defaults = defaults;
		defaults = current_service;
		current_service = saved_defaults;

		/* copy new defaults to current_service */
		service_free(current_service);
		service_copy(current_service, defaults);

		/* save default opmetalist */
		opmetalist_free(opml_defaults);
		free(opml_defaults);
		opml_defaults = (yyvsp[(3) - (4)].opml);
	}
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 268 "grammar.y"
    {
		struct opmetalist *parent;
		struct opmetalist *onexit;
		struct oplist *ops;
		int i;
		int fds;
		fd_set *fdst;

		parent = opmetalist_new();
		onexit = opmetalist_new();

		current_service->name = (yyvsp[(2) - (5)].cp);
		current_service->opfixups[ofp_iname] = stringtab_add((yyvsp[(2) - (5)].cp));

		do { /* avoid goto */

			if (current_service->disabled)
				break;

			if(current_service->socktype == SOCK_STREAM && !current_service->wait) {
				if(opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_ACCEPT, 200))) { /* !200 */
					RL_PWARN(_("opcode resolving problem"));
					current_service->disabled++;
					break;
				}
				opmetalist_add(parent, opmeta_make(1, OP_CLOSE));

				if (current_service->internal)
					opmetalist_add(onexit, opmeta_make(1, OP_CLOSE));
				else
					opmetalist_add(onexit, opmeta_make(1, OP_RET));

			} else {
				opmetalist_add(parent, opmeta_make(1, OP_RET));
				opmetalist_add(onexit, opmeta_make(1, OP_RET));
			}
			validate_service(current_service);


			if (current_service->disabled)
				break;

			if (!add_user_group(current_service, (yyvsp[(4) - (5)].opml)))
			{
				++current_service->disabled;
			  break;
		  }


			fds = bind_ports();


			if(current_service->limit) {
				struct opmetalist *o;
				struct oplist *l;
				int match, under;

				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LCLR, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o, current_service->opfixups);
				match = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);

				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LSET, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o, current_service->opfixups);
				under = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);

				i = semaphore_add(current_service->limit, match, under);
				opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_DOWN, i));
				opmetalist_add(onexit, opmeta_make(2, OP_UP, i));
			}
			ops = opmetalist_resolve(onexit, current_service->opfixups);
			current_service->opfixups[ofp_onexit] = oplisttab_add(ops);
			opmetalist_free(onexit);
			free(onexit);
			oplist_free(ops);
			free(ops);

			ops = opmetalist_resolve(parent, current_service->opfixups);
			current_service->opfixups[ofp_parent] = oplisttab_add(ops);
			opmetalist_free(parent);
			free(parent);
			oplist_free(ops);
			free(ops);

			opmetalist_merge((yyvsp[(4) - (5)].opml), opml_defaults);

			opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_JUMP, current_service->opfixups[ofp_onexit]));
			ops = opmetalist_resolve((yyvsp[(4) - (5)].opml), current_service->opfixups);

			current_service->run = oplisttab_add(ops);
			opmetalist_free((yyvsp[(4) - (5)].opml));
			free((yyvsp[(4) - (5)].opml));
			oplist_free(ops);
			free(ops);

			fdst = fdsettab_get(fds);
			for(i = 0; i < FD_SETSIZE; i++)
				if(FD_ISSET(i, fdst))
					read_hook(i, oplisttab_get(current_service->run), NULL);

		} while (0);

		if (current_service->disabled) {
					rl_warn(_("service %s DISABLED"), current_service->name);
		} else {
			rl_note(_("service %s enabled"), current_service->name);
			if (rl_debug > 1)
				rl_note(_("+-> uid=%d, sgid=%d, supgid=%d fl=%d"), current_service->opfixups[ofp_setuid],
					current_service->opfixups[ofp_setgid], current_service->opfixups[ofp_supgid], current_service->sflags);

		}

		service_free(current_service);
		service_copy(current_service, defaults);
	}
    break;

  case 22:
/* Line 1787 of yacc.c  */
#line 397 "grammar.y"
    {
		(yyval.opml) = opmetalist_new();
	}
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 401 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 405 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 416 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 424 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
	}
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 432 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 438 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 442 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 453 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 461 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
	}
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 471 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;

		l = opmetalist_new();
		o = opmeta_make(3, OP_EXEC, 666, argvtab_add((yyvsp[(2) - (3)].cp), 1));
		opmeta_fixup(o, 1, ofp_exec);
		if(opmetalist_add(l, o)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		o = opmeta_make(3, OP_FORK, 666, 666);
		opmeta_fixup(o, 1, ofp_parent);
		opmeta_fixup(o, 2, ofp_onexit);
		if(opmetalist_add(l, o)) {
			RL_PWARN(_("opcode resolving problem"));
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 492 "grammar.y"
    {
		if((yyvsp[(2) - (3)].uid)) {

			current_service->opfixups[ofp_iuser] = stringtab_add((yyvsp[(2) - (3)].uid)->pw_name);
			current_service->opfixups[ofp_setuid] = (yyvsp[(2) - (3)].uid)->pw_uid;
			current_service->opfixups[ofp_supgid] = (yyvsp[(2) - (3)].uid)->pw_gid;

			set_flag(current_service, FLAG_USER);

			if(!has_flag(current_service, FLAG_GROUP)) {
				current_service->opfixups[ofp_setgid] = (yyvsp[(2) - (3)].uid)->pw_gid;
			}

			(yyval.opml) = NULL;
		} else {
			RL_PWARN("unknown username");
			current_service->disabled++;
			(yyval.opml) = NULL;
		}
	}
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 513 "grammar.y"
    {
		set_flag(current_service, FLAG_INITGROUPS);

		(yyval.opml) = NULL;

	}
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 520 "grammar.y"
    {
		if ((yyvsp[(2) - (3)].num))
			set_flag(current_service, FLAG_INITGROUPS);
		else
			reset_flag(current_service, FLAG_INITGROUPS);
		(yyval.opml) = NULL;
	}
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 530 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_NICE, (yyvsp[(2) - (3)].num));
	}
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 534 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_FISH);
	}
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 538 "grammar.y"
    {
		(yyval.opm) = opmeta_make(3, OP_RLIMIT, (yyvsp[(2) - (3)].num), (yyvsp[(3) - (3)].num));
	}
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 542 "grammar.y"
    {
		int i;

		i = logtab_add(-1, (yyvsp[(3) - (4)].cp));
		(yyval.opm) = opmeta_make(2, OP_LOG, i);
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 550 "grammar.y"
    {
		int ret;

		ret = buftab_addfile((yyvsp[(2) - (3)].cp));
		if(ret == -1)
			current_service->disabled++;
		(yyval.opm) = opmeta_make(16, OP_ZERO, OP_BUFCLONE, ret, OP_WHOOK, 0, OP_WUNHOOK,
										 OP_DUP, OP_BUFCOPY, OP_DUP, OP_BZNEG, 3, OP_ADD,
										 OP_WHOOK, -9, OP_POP, OP_BUFFREE);
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 562 "grammar.y"
    {
		int i;

		if((yyvsp[(2) - (3)].cp)) {
			i = buftab_addfile((yyvsp[(2) - (3)].cp));
			if(i < 0)
				current_service->disabled++;
		} else {
			i = chargen_buffer();
		}
		(yyval.opm) = opmeta_make(25, OP_ZERO, OP_DUP, OP_BUFCLONE, i, OP_POP,
										 OP_POP, OP_ZERO, OP_WHOOK, 0, OP_WUNHOOK, OP_DUP,
										 OP_BUFCOPY, OP_DUP, OP_BZ, -11, OP_DUP, OP_BZNEG, 3,
										 OP_ADD, OP_WHOOK, -12, OP_POP, OP_BUFFREE, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 24, ofp_onexit);
		current_service->internal = 1;
		if((yyvsp[(2) - (3)].cp))
			free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 582 "grammar.y"
    {
		struct logdata *ld = logdata_get((yyvsp[(2) - (4)].cp));

		if(!ld) {
			RL_PWARN(_("unknown log %s"), (yyvsp[(2) - (4)].cp));
			current_service->disabled++;
		} else {
			int i = logtab_add(ld->index, (yyvsp[(3) - (4)].cp));
			(yyval.opm) = opmeta_make(2, OP_LOG, i);
		}
		free((yyvsp[(2) - (4)].cp));
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 596 "grammar.y"
    {
		if(!(yyvsp[(2) - (3)].gid)) {
			RL_PWARN(_("unknown group"));
			current_service->disabled++;
			(yyval.opm) = NULL;
		} else {

			current_service->opfixups[ofp_setgid] = (yyvsp[(2) - (3)].gid)->gr_gid;
			set_flag(current_service, FLAG_GROUP);

			(yyval.opm) = NULL;
		}
	}
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 610 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_CHROOT, argvtab_add((yyvsp[(2) - (3)].cp), 1));
	}
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 614 "grammar.y"
    {
#ifdef HAVE_CAPABILITIES
		cap_t current_caps = cap_from_text((yyvsp[(2) - (3)].cp));
		if(current_caps) {
			(yyval.opm) = opmeta_make(2, OP_SETCAP, captab_add(current_caps));
		} else {
			RL_PWARN(_("failed to parse capability string \"%s\"\n"), (yyvsp[(2) - (3)].cp));
			current_service->disabled++;
		}
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, _("ABORT - support for capabilities not compiled in"));
#endif
	}
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 629 "grammar.y"
    {
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(4) - (5)].opml),current_service->opfixups);
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (5)].cp)), i);
		free((yyvsp[(2) - (5)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(4) - (5)].opml));
		free((yyvsp[(4) - (5)].opml));
	}
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 644 "grammar.y"
    {
		struct opmeta *o;
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(3) - (4)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(3) - (4)].opml), current_service->opfixups);
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, ofp_iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(3) - (4)].opml));
		free((yyvsp[(3) - (4)].opml));
	}
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 661 "grammar.y"
    {
		struct opmetalist *l;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l, current_service->opfixups);
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (3)].cp)), i);
		free((yyvsp[(2) - (3)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 678 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l,current_service->opfixups);
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, ofp_iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 697 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_CLOSE);
	}
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 701 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_EXIT);
	}
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 705 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_ECHO, argvtab_add((yyvsp[(2) - (3)].cp), 0));
	}
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 709 "grammar.y"
    {
		(yyval.opm) = opmeta_make(29, OP_ZERO, OP_BUFINIT, 11, OP_RHOOK, 0, OP_BUFREAD,
										 OP_RUNHOOK, OP_DUP, OP_BZNEG, 17, OP_ADD, OP_WHOOK, 0,
										 OP_BUFWRITE, OP_WUNHOOK, OP_DUP, OP_BZ, 6, OP_DUP,
										 OP_BZNEG, 6, OP_SUB, OP_WHOOK, -11, OP_POP, OP_RHOOK, -22,
										 OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 28, ofp_onexit);
		current_service->internal = 1;
	}
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 719 "grammar.y"
    {
		(yyval.opm) = opmeta_make(13, OP_ZERO, OP_RHOOK, 0, OP_RUNHOOK, OP_BUFINIT, 1024,
										 OP_BUFREAD, OP_BZNEG, 2, OP_RHOOK, -8, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 12, ofp_onexit);
		current_service->internal = 1;
	}
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 728 "grammar.y"
    {	(yyval.cp) = NULL;	}
    break;

  case 58:
/* Line 1787 of yacc.c  */
#line 734 "grammar.y"
    {
		if(current_service->port)
			stringlist_free(current_service->port);
		current_service->port = stringlist;
		stringlist = NULL;
	}
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 741 "grammar.y"
    {
		current_service->socktype = (yyvsp[(2) - (3)].num);
	}
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 745 "grammar.y"
    {
		current_service->backlog = (yyvsp[(2) - (3)].num);
	}
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 749 "grammar.y"
    {
		current_service->limit = (yyvsp[(2) - (3)].num);
	}
    break;

  case 62:
/* Line 1787 of yacc.c  */
#line 753 "grammar.y"
    {
		current_service->wait  = (yyvsp[(2) - (3)].num);
	}
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 757 "grammar.y"
    {
		current_service->disabled  = ! (yyvsp[(2) - (3)].num);
	}
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 761 "grammar.y"
    {
		if(current_service->interface)
			stringlist_free(current_service->interface);
		current_service->interface = stringlist;
		stringlist = NULL;
	}
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 768 "grammar.y"
    {
		if(current_service->interface)
			stringlist_free(current_service->interface);
		current_service->interface = NULL;
	}
    break;

  case 66:
/* Line 1787 of yacc.c  */
#line 774 "grammar.y"
    {
		current_service->opfixups[ofp_exec] = stringtab_add((yyvsp[(2) - (3)].cp));
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 69:
/* Line 1787 of yacc.c  */
#line 781 "grammar.y"
    {
#ifdef HAVE_NET_BPF_H
		if(current_service->filter)
			free(current_service->filter);
		if(rl_readfile((yyvsp[(2) - (3)].cp), &current_service->filter, &current_service->filterlen))
			current_service->disabled++;
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, _("ABORT - support for socket filter not compiled in"));
#endif
	}
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 800 "grammar.y"
    {
		current_service->rpcname = (yyvsp[(2) - (3)].cp);
	}
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 804 "grammar.y"
    {
		current_service->rpcvers = numlist;
		numlist = NULL;
	}
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 815 "grammar.y"
    {
		numlist_add(&numlist, (yyvsp[(1) - (1)].num));
	}
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 819 "grammar.y"
    {
		int i;

		if((yyvsp[(3) - (3)].num) >= (yyvsp[(1) - (3)].num))
			for(i = (yyvsp[(1) - (3)].num); i <= (yyvsp[(3) - (3)].num); i++)
				numlist_add(&numlist, i);
	}
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 833 "grammar.y"
    {
		current_service->r.rlim_cur = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 837 "grammar.y"
    {
		current_service->r.rlim_max = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 84:
/* Line 1787 of yacc.c  */
#line 847 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 87:
/* Line 1787 of yacc.c  */
#line 857 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 861 "grammar.y"
    {
		char tmp[20];

		snprintf(tmp, 19, "%ld", (yyvsp[(1) - (1)].num));
		tmp[19] = '\0';
		stringlist_add(&stringlist, strdup(tmp));
	}
    break;

  case 89:
/* Line 1787 of yacc.c  */
#line 871 "grammar.y"
    {
		(yyval.num) = rlimittab_add((yyvsp[(1) - (2)].rl), (yyvsp[(1) - (2)].rl));
	}
    break;

  case 90:
/* Line 1787 of yacc.c  */
#line 875 "grammar.y"
    {
		if((current_service->r.rlim_max != RLIM_INFINITY) &&
			 (current_service->r.rlim_cur > current_service->r.rlim_max)) {
			RL_PWARN(_("invalid resource limit"));
		}
		(yyval.num) = rlimittab_add(current_service->r.rlim_cur, current_service->r.rlim_max);
		current_service->r.rlim_cur = current_service->r.rlim_max = RLIM_INFINITY;
	}
    break;

  case 91:
/* Line 1787 of yacc.c  */
#line 886 "grammar.y"
    { (yyval.rl) = (rlim_t)(yyvsp[(1) - (1)].num); }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 888 "grammar.y"
    { (yyval.rl) = RLIM_INFINITY; }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 892 "grammar.y"
    {
#ifdef RLIMIT_CPU
		(yyval.num) = RLIMIT_CPU;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "cpu");
#endif
	}
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 901 "grammar.y"
    {
#ifdef RLIMIT_FSIZE
		(yyval.num) = RLIMIT_FSIZE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "fsize");
#endif
	}
    break;

  case 95:
/* Line 1787 of yacc.c  */
#line 910 "grammar.y"
    {
#ifdef RLIMIT_DATA
		(yyval.num) = RLIMIT_DATA;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "data");
#endif
	}
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 919 "grammar.y"
    {
#ifdef RLIMIT_STACK
		(yyval.num) = RLIMIT_STACK;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "stack");
#endif
	}
    break;

  case 97:
/* Line 1787 of yacc.c  */
#line 928 "grammar.y"
    {
#ifdef RLIMIT_CORE
		(yyval.num) = RLIMIT_CORE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "core");
#endif
	}
    break;

  case 98:
/* Line 1787 of yacc.c  */
#line 937 "grammar.y"
    {
#ifdef RLIMIT_RSS
		(yyval.num) = RLIMIT_RSS;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "rss");
#endif
	}
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 946 "grammar.y"
    {
#ifdef RLIMIT_NPROC
		(yyval.num) = RLIMIT_NPROC;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "nproc");
#endif
	}
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 955 "grammar.y"
    {
#ifdef RLIMIT_NOFILE
		(yyval.num) = RLIMIT_NOFILE;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "nofile");
#endif
	}
    break;

  case 101:
/* Line 1787 of yacc.c  */
#line 964 "grammar.y"
    {
#ifdef RLIMIT_MEMLOCK
		(yyval.num) = RLIMIT_MEMLOCK;
#else
		RL_PFATAL(EX_DATAERR, _("%s limit not available on this system"), "memlock");
#endif
	}
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 974 "grammar.y"
    {
		(yyval.uid) = getpwuid((yyvsp[(1) - (1)].num));
		endpwent();
	}
    break;

  case 103:
/* Line 1787 of yacc.c  */
#line 979 "grammar.y"
    {
		(yyval.uid) = getpwnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endpwent();
	}
    break;

  case 104:
/* Line 1787 of yacc.c  */
#line 987 "grammar.y"
    {
		(yyval.gid) = getgrgid((yyvsp[(1) - (1)].num));
		endgrent();
	}
    break;

  case 105:
/* Line 1787 of yacc.c  */
#line 992 "grammar.y"
    {
		(yyval.gid) = getgrnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endgrent();
	}
    break;

  case 106:
/* Line 1787 of yacc.c  */
#line 1000 "grammar.y"
    {
		(yyval.num) = SOCK_STREAM;
		current_service->protoname = "tcp";
		current_service->proto = IPPROTO_TCP;
	}
    break;

  case 107:
/* Line 1787 of yacc.c  */
#line 1006 "grammar.y"
    {
		(yyval.num) = SOCK_DGRAM;
		current_service->protoname = "udp";
		current_service->proto = IPPROTO_UDP;
	}
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 1014 "grammar.y"
    {
		current_service->family = PF_INET;
	}
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 1018 "grammar.y"
    {
#ifdef HAVE_SOCKADDR_IN6
		current_service->family = PF_INET6;
#else
		RL_PWARN(_("ipv6 support is not compiled in"));
		current_service->family = PF_INET;
#endif
	}
    break;

  case 110:
/* Line 1787 of yacc.c  */
#line 1029 "grammar.y"
    {
		(yyval.num) = (yyvsp[(1) - (1)].num);
	}
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 1033 "grammar.y"
    {
		(yyval.num) = (-(yyvsp[(2) - (2)].num));
	}
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 1039 "grammar.y"
    {
		(yyval.num) = 1;
	}
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 1043 "grammar.y"
    {
		(yyval.num) = 0;
	}
    break;


/* Line 1787 of yacc.c  */
#line 2966 "grammar.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 1047 "grammar.y"


void yyerror(const char *str) {
	RL_PFATAL(EX_DATAERR, _("ABORT - %s"), str);
}

int yywrap(void) {
	fclose(yyin);
	if(numfiles) {
		while(++curfile < numfiles) {
			if((yyin = fopen(files[curfile], "r"))) {
				curfile_name = files[curfile];
				curfile_line = 1;
				return 0;
			} else {
				curfile_name = NULL;
				RL_PWARN(_("cannot open file %s (%s)"), files[curfile],
						strerror(errno));
			}
		}
	}
	return 1;
}

static struct service *service_new() {
	struct service *p = (struct service *)malloc(sizeof(*p));

	if (!p)
		rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
	memset(p, 0, sizeof(*p));
	return p;
}

void services_free() {
	if(rl_cleanups) {
		rlp_cleanup(rl_cleanups);
		rl_cleanups = NULL;
	}
}

static void validate_service(struct service *s) {
	if(!s->name) {
		RL_PWARN(_("service without name"));
		s->disabled++;
		return;
	}

	if (!has_flag(s, FLAG_USER)) {
		RL_PWARN(_("user is not set for service %s"), s->name);
		s->disabled++;
		return;
	}

	if (s->wait && s->limit != 1) {
		if (s->limit != defaults->limit)
			RL_PWARN(_("ignoring `instances %d' directive for service %s, because `wait' was also given"),
										s->limit, s->name);
		s->limit = 1;
	}

	if(s->rpcvers) {
		const char *rpcname = s->name;
		struct rpcent *rep;

		if(s->rpcname)
			rpcname = s->rpcname;
		rep = getrpcbyname(rpcname);
		if(!rep) {
			RL_PWARN(_("can't find rpc service %s for service %s"),
							rpcname, s->name);
			s->disabled++;
		} else {
			s->rpcnum = rep->r_number;
		}
		endrpcent();
	}
}

static in_port_t get_rpc_port(struct service * cur_service)
{
	if (!cur_service->rpcnum)
		return 0;
	const struct numlist *vers = cur_service->rpcvers;
	struct sockaddr_in myaddress;
	get_myaddress(&myaddress);
	in_port_t result = 0;
	do {
		const in_port_t port = pmap_getport(&myaddress, cur_service->rpcnum, vers->num,
																				cur_service->proto);
		if (rl_debug > 1)
			rl_note("++ pmap_getport(?, %d, %d, %d) for service %s returned %d",
												cur_service->rpcnum, vers->num, cur_service->proto,
												cur_service->name, port);
		if (result && port && result != port) {
			RL_PWARN("rpc service %s already registered on different ports: %d and %d",
								cur_service->name, port, result);
			++cur_service->disabled;
		} else if (port) {
			result = port;
		}
	} while((vers = vers->next));

	return result;
}

static int register_rpc_service(int * rpc_registered,
																const struct service * const cur_service,
																const in_port_t rpc_port)
{
	if (*rpc_registered)
		return 1;

	const struct numlist *vers = cur_service->rpcvers;

	do {
		if (rl_debug > 1)
			rl_note("++ calling pmap_set(%d, %d, %d, %d) for service %s",
							cur_service->rpcnum, vers->num, cur_service->proto, rpc_port,
							cur_service->name);

		if(pmap_set(cur_service->rpcnum, vers->num, cur_service->proto, rpc_port))
			++*rpc_registered;
		else
			RL_PWARN(_("pmap_set(%d, %d, %d, %d) failed for service %s"),
				cur_service->rpcnum, vers->num, cur_service->proto, rpc_port,
				cur_service->name);
		} while((vers = vers->next));

		if (*rpc_registered) {
			struct rl_cleanup *p = (struct rl_cleanup *)malloc(sizeof(struct rl_cleanup));
			if (!p)
				rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
			p->next = rl_cleanups;
			p->data =	(struct rlc_unrpc *)malloc(sizeof(struct rlc_unrpc));
			if (!p->data)
				rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
			p->type = RLC_UNRPC;
			((struct rlc_unrpc *)p->data)->vers = NULL;
			numlist_copy(&(((struct rlc_unrpc *)p->data)->vers), cur_service->rpcvers);
			((struct rlc_unrpc *)p->data)->prog =	cur_service->rpcnum;
			rl_cleanups = p;
		}
		else if (rl_debug > 1)
			rl_note("++pmap_set() failed for all versions of service %s", cur_service->name);
		return *rpc_registered;
}

static int bind_ports() {
	int fd;
	long opt = 1;
	struct stringlist *portp;
	struct stringlist *ifp;
#ifdef HAVE_GETADDRINFO
	struct addrinfo hints;
	struct addrinfo *results = NULL, *ai;
	int ret;
#else
	void *addrbuf;
	int portnum;
	char *ctmp;
#endif
	const char *port, *addr;
	const char *lasterror;
	const char *errfunc = NULL;
	int succeeded;
	fd_set fds;
	int n_fds;

	int family, socktype, protocol;
	socklen_t saddrlen;
	struct sockaddr *saddr = NULL;
	int rpc_registered = 0;
	in_port_t rpc_port = get_rpc_port(current_service);

	if (current_service->disabled)
		return 0;

	FD_ZERO(&fds);
	n_fds = 0;
	ifp = current_service->interface;
	do {
		addr = ifp ? ifp->str : NULL;
		portp = current_service->port;
		do {
			lasterror = NULL;
			succeeded = 0;

			port = portp ? portp->str : !current_service->rpcnum ? current_service->name : "0";
#ifdef HAVE_GETADDRINFO
			memset(&hints, 0, sizeof(hints));
			hints.ai_flags = AI_PASSIVE;
			hints.ai_family = current_service->family;
			hints.ai_socktype = current_service->socktype;
			hints.ai_protocol = current_service->proto;
			if(results)
				freeaddrinfo(results);
			results = NULL;
			if((ret = getaddrinfo(addr, port, &hints, &results))) {
#ifdef HAVE_GAI_STRERROR
				RL_PWARN(_("getaddrinfo(%s, %s) failed: %s"), addr, port,
								gai_strerror(ret));
#else
				RL_PWARN(_("getaddrinfo(%s, %s) failed: %s"), addr, port,
								_("for reasons unknown") );
#endif
				continue;
			}
			ai = results;
			do {
				family = ai->ai_family;
				socktype = ai->ai_socktype;
				protocol = ai->ai_protocol;
				saddr = ai->ai_addr;
				saddrlen = ai->ai_addrlen;
#else
				portnum = strtoul(port, &ctmp, 10);
				if(*ctmp) {
					portnum = getservport(port, current_service->protoname);
					if(portnum == -1) {
						RL_PWARN(_("Failed to resolve %s, protocol %s"),
										current_service->proto, port);
						continue;
					}
				}
				family = current_service->family;
				socktype = current_service->socktype;
				protocol = current_service->proto;
				if(saddr) {
					free(saddr);
					saddr = NULL;
				}
				switch(family) {
					struct sockaddr_in *sin;
#ifdef HAVE_SOCKADDR_IN6
					struct sockaddr_in6 *sin6;
#endif

					case PF_INET:
						saddrlen = sizeof(struct sockaddr_in);
						sin = (struct sockaddr_in *)malloc(saddrlen);
						if (!sin)
							rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
						addrbuf = &sin->sin_addr.s_addr;
						sin->sin_family = current_service->family;
						sin->sin_port = htons(portnum);
						sin->sin_addr.s_addr = INADDR_ANY;
						saddr = (struct sockaddr *)sin;
						break;
#ifdef HAVE_SOCKADDR_IN6
					case PF_INET6:
						saddrlen = sizeof(struct sockaddr_in6);
						sin6 = (struct sockaddr_in6 *)malloc(saddrlen);
						if (!sin6)
							rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
						addrbuf = &sin6->sin_addr.s_addr;
						sin6->sin6_family = current_service->family;
						sin6->sin6_port = htons(portnum);
						sin6->sin6_addr = IN6ADDR_ANY_INIT;
						saddr = (struct sockaddr *)sin6;
						break;
#endif
					default:
						RL_PFATAL(EX_SOFTWARE, _("funky family in service"));
				}
				if(addr) {
					if(
#ifdef HAVE_INET_PTON
						 inet_pton(family, addr, addrbuf)
#else
																/* this cast is a pain */
						 (*(unsigned int *)addrbuf = inet_addr(addr)) == -1
#endif
						 ) {
						RL_PWARN(_("bad address %s in service %s"), addr,
										current_service->name);
						free(saddr);
						saddr = NULL;
						continue;
					}
				}
#endif
				if((fd = socket(family, socktype, protocol)) < 0) {
					lasterror = strerror(errno);
					errfunc = "socket()";
					goto out;
				}
				if(setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt))) {
					RL_PWARN(_("setsockopt(%d, SOL_SOCKET, SO_REUSEADDR, 1) failed for service %s (%s)"),
									fd, current_service->name, strerror(errno));
				}
#ifdef HAVE_NET_BPF_H
				if(current_service->filter) {
					struct bpf_program bp;

					bp.bf_len = current_service->filterlen / sizeof(struct bpf_insn);
					bp.bf_insns = current_service->filter;
					if(setsockopt(fd, SOL_SOCKET, SO_ATTACH_FILTER, &bp, sizeof(bp))) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "setsockopt(..., SO_ATTACH_FILTER)";
						goto out;
					}
				}
#endif
				/* For rpc service bind to the same port as it was already registered */
				if(current_service->rpcnum && rpc_port) {
					/* Note: this should be either sockaddr_in or sockaddr_in6, but fortunatelly
							the port is at the same place in both structures. */
					((struct sockaddr_in *)saddr)->sin_port = htons(rpc_port);
				}

				if(bind(fd, saddr, saddrlen) < 0) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "bind()";
					goto out;
				}

				if(current_service->rpcnum) {

					if (!rpc_port) {
						if (getsockname(fd, saddr, &saddrlen) == -1) {
							lasterror = strerror(errno);
							close(fd);
							errfunc = "getsockname()";
							goto out;
						}
						/* Note: this should be either sockaddr_in or sockaddr_in6, but fortunatelly
								the port is at the same place in both structures. */
						rpc_port = ntohs(((struct sockaddr_in *)saddr)->sin_port);
						if (!rpc_port) { /* shouldn't happen */
								lasterror = "returned port is 0";
								close(fd);
								errfunc = "getsockname()";
								goto out;
						}
					}

					if(!register_rpc_service(&rpc_registered, current_service, rpc_port)) {
						close(fd);
						goto out_all_loops;
					}
				}
				FD_SET(fd, &fds);
				if(socktype == SOCK_STREAM) {
					if(listen(fd, current_service->backlog)) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "listen(fd)";
						goto out;
					}
				}
				if(fcntl(fd, F_SETFD, 1)) {
					lasterror = strerror(errno);
					errfunc = "fcntl(fd, F_SETFD, 1)";
					close(fd);
					goto out;
				}
				if(fcntl(fd, F_SETFL, O_NDELAY)) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "fcntl(fd, F_SETFL, O_NDELAY)";
					goto out;
				}
				n_fds++;
				succeeded++;
			out:
#ifdef HAVE_GETADDRINFO
				continue;
			} while((ai = ai->ai_next));
#endif
			if(!succeeded && lasterror)
				RL_PWARN(_("%s failed for service %s: %s"),
								errfunc, current_service->name, lasterror);
		} while(portp && (portp = portp->next));
	} while(ifp && (ifp = ifp->next));
out_all_loops:
	stringlist_free(current_service->port);
	current_service->port = NULL;
	stringlist_free(current_service->interface);
	current_service->interface = NULL;
	numlist_free(current_service->rpcvers);
	current_service->rpcvers = NULL;
#ifdef HAVE_GETADDRINFO
	if(results) {
		freeaddrinfo(results);
		results = NULL;
	}
#else
	if(saddr) {
		free(saddr);
		saddr = NULL;
	}
#endif
	if (!n_fds)
		current_service->disabled++;
	return fdsettab_add(&fds);
}

static int add_user_group(const struct service* s, struct opmetalist * l)
{
	struct opmeta *o = NULL;
	if (has_flag(s, FLAG_USER))
	{
		o = opmeta_make(2, OP_SUID, 666);
		opmeta_fixup(o, 1, ofp_setuid);
		if(opmetalist_add(l, o)) {
				RL_PWARN(_("opcode resolving problem"));
				return 0;
		}
	}

	if (has_flag(s, FLAG_USER) || (has_flag(s, FLAG_GROUP)))
	{
				o = opmeta_make(2, OP_SGID, 666);
				opmeta_fixup(o, 1, ofp_setgid);
				if(opmetalist_add(l, o)) {
					RL_PWARN(_("opcode resolving problem"));
				  return 0;
				}
	}

	if (has_flag(s, FLAG_USER) && has_flag(s, FLAG_INITGROUPS))
	{
			o = opmeta_make(3, OP_INITGR, 666, 666);
			opmeta_fixup(o, 1, ofp_iuser);
			opmeta_fixup(o, 2, ofp_supgid);
			if(opmetalist_add(l, o)) {
				RL_PWARN(_("opcode resolving problem"));
			 return 0;
		}
	}
	return 1;
}

static void service_free(struct service *s) {
	if(s->name) {
		free(s->name);
		s->name = NULL;
	}
	stringlist_free(s->port);
	s->port = NULL;
	stringlist_free(s->interface);
	s->interface = NULL;
	if(s->rpcname) {
		free(s->rpcname);
		s->rpcname = NULL;
	}
	if(s->rpcvers) {
		numlist_free(s->rpcvers);
		s->rpcvers = NULL;
	}
#ifdef HAVE_CAPABILITIES
	if(s->caps) {
		cap_free(&s->caps);
		s->caps = NULL;
	}
#endif
#ifdef HAVE_NET_BPF_H
	if(s->filter) {
		free(s->filter);
		s->filter = NULL;
		s->filterlen = 0;
	}
#endif
}

static void service_copy(struct service *to, struct service *from) {
	memcpy(to, from, sizeof(*to));
	to->name = NULL;
	to->port = NULL;
	to->interface = NULL;
	stringlist_copy(&to->port, from->port);
	stringlist_copy(&to->interface, from->interface);
	to->rpcname = from->rpcname ? strdup(from->rpcname) : NULL;
	to->rpcvers = NULL;
	numlist_copy(&to->rpcvers, from->rpcvers);
#ifdef HAVE_LIBCAP
	to->caps = from->caps ? cap_dup(from->caps) : NULL;
#endif
#ifdef HAVE_NET_BPF_H
	if(from->filter) {
		to->filter = malloc(from->filterlen);
		if (!to->filter)
			rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
		memcpy(to->filter, from->filter, from->filterlen);
	}
#endif
}

static struct logdata *logdata_get(char *name) {
	struct logdata *ptr = logdatas;

	if(!ptr)
		return NULL;
	do {
		if(!strcmp(name, ptr->name))
			return ptr;
	} while((ptr = ptr->next));
	return NULL;
}

static void logdatas_free(void) {
	struct logdata *p, *q;

	p = logdatas;
	while(p) {
		q = p->next;
		if(p->name)
			free(p->name);
		if(p->path)
			free(p->path);
		free(p);
		p = q;
	}
	logdatas = NULL;
}

static struct logdata *logdata_new() {
	struct logdata *ptr = (struct logdata *)malloc(sizeof(*ptr));

	if (!ptr)
		rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));

	memset(ptr, 0, sizeof(*ptr));
	ptr->index = -1;
	ptr->mode =
#ifdef S_IRUSR
		S_IRUSR|S_IWUSR|S_IRGRP
#else
		0640
#endif
		;
	ptr->uid = -1;
	ptr->gid = -1;
	return ptr;
}

extern void parse(void);
void parse(void) {

	numlist = NULL;
	userdata = NULL;
	newuserdata(&userdata);
	pidtab_fixup();
	all_unhook();
	logtabs_free();
	argvtabs_free();
	rlimittabs_free();
	services_free();
	stringtabs_free();
	buftabs_free();
	oplisttabs_free();
#ifdef HAVE_CAPABILITIES
	captabs_free();
#endif
	semaphores_free();
	fdsettabs_free();
	if(strcmp(rl_config, "-") || !rl_debug) {
		if(!(yyin = fopen(rl_config, "r"))) {
			RL_PFATAL(EX_NOINPUT, _("fopen(%s) failed, aborting"), rl_config);
		} else {
			curfile_name = rl_config;
			curfile_line = 1;
		}
	}

	logcur = logdata_new();
	current_service = service_new();
	defaults = service_new();
#ifdef HAVE_GETADDRINFO
	defaults->family = PF_UNSPEC;
#else
	defaults->family = PF_INET;
#endif
	defaults->socktype = SOCK_STREAM;
	defaults->protoname = "tcp";
	defaults->proto = IPPROTO_TCP;
	defaults->backlog = 5;
	defaults->limit = 40;
	defaults->r.rlim_cur = RLIM_INFINITY;
	defaults->r.rlim_max = RLIM_INFINITY;
	defaults->wait = 0;


	defaults->opfixups[ofp_exec] = -1;

	defaults->opfixups[ofp_iname] = -1;
	defaults->opfixups[ofp_parent] = -1;
	defaults->opfixups[ofp_iuser]  = -1;
	defaults->sflags =  0;
	defaults->opfixups[ofp_supgid] = -1;
	defaults->opfixups[ofp_setgid] = -1;
	defaults->opfixups[ofp_setuid] = -1;
	service_copy(current_service, defaults);
	 opml_defaults = opmetalist_new();
	yyparse();
	freebufs();
	service_free(defaults);
	free(defaults);
	defaults = NULL;
	logdatas_free();
	free(logcur);
	logcur = NULL;
	service_free(current_service);
	free(current_service);
	current_service = NULL;
	for(curfile = 0; curfile < numfiles; curfile++) {
		free(files[curfile]);
		files[curfile] = NULL;
	}
	free(files);
	files = NULL;
	clearuserdata(&userdata);
	free(userdata);
}

static void pidtab_fixup() {
	struct pidtab *p;
	int i;

	for(i = 0; i < 8; i++) {
		p = pidtabs[i].next;
		while(p) {
			if(p->inst)
				inst_free(p->inst);
			p->inst = NULL;
			p = p->next;
		}
	}
}

#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto) {
	struct servent *foo;
	int ret = -1;

	foo = getservbyname(str, proto);
	if(foo)
		ret = ntohs(foo->s_port);
	endservent();
	return ret;
}
#endif

static void add_directory(char *dir, char *match, char *ignore) {
	DIR *d;
	struct dirent *de;
	regex_t rmatch, rignore;
	char err[128];
	int e;
	struct stat st;
	char *file;

	if(match)
		if((e = regcomp(&rmatch, match, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rmatch, err, 127);
			RL_PWARN(_("regexp compile failed for directory %s: %s"),
							dir, err);
		}
	if(ignore)
		if((e = regcomp(&rignore, ignore, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rignore, err, 127);
			RL_PWARN(_("regexp compile failed for directory %s: %s"),
							dir, err);
		}

	if((d = opendir(dir))) {
		while((de = readdir(d))) {
			if(match)
				if(regexec(&rmatch, de->d_name, 0, NULL, 0))
					continue;
			if(ignore)
				if(!regexec(&rignore, de->d_name, 0, NULL, 0))
					continue;
			if(de->d_name[0] != '.') {
				file = malloc(strlen(dir) + NAMLEN(de) + 2);
				if (!file)
					rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
				file[0] = '\0';
				strcat(file, dir);
				strcat(file, "/");
				strcat(file, de->d_name);
				if(stat(file, &st) || S_ISDIR(st.st_mode)) {
					RL_PWARN(_("file %s does not exists or"
						 " is a directory"), file);
					free(file);
					continue;
				}
				files = (char **)realloc(files, ++numfiles * sizeof(char *));
				if (!files)
					rl_fatal(EX_SOFTWARE, _("ABORT - Can't allocate memory"));
				files[numfiles - 1] = file;
			}
		}
	} else {
		RL_PFATAL(EX_NOINPUT, _("Directory %s open failed (%s)"), dir,
			strerror(errno));
	}
	closedir(d);
	free(dir);
	if(match) {
		free(match);
		regfree(&rmatch);
	}
	if(ignore) {
		free(ignore);
		regfree(&rignore);
	}
}

int chargen_buffer() {
	static int cb = -1;
	const char * const b = "01234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n";

	if(cb == -1)
		cb = buftab_addbuf(b, strlen(b));
	return cb;
}


/* vim: set ts=2 sts=2 noet: */
